%module ppl_ta_int

%{
#define SWIG_FILE_WITH_INIT
#include "ppl_ta_int.h"
%}

%include "std_string.i"
%include "std_vector.i"
%include "typemaps.i"

namespace std {
   %template(IntVector) vector<int>;
}

enum Degenerate_Element {UNIVERSE,EMPTY};

class ParamGuard {
 
  public:
    ParamGuard (int i, int j, int delta, int c, int d, int sign);
    ParamGuard (int i, int delta, int c, int d, int sign);
    std::string toStr() const;
};


class ParamFederation 
{
  public:
    ParamFederation(int num_dimensions=0,Degenerate_Element kind=UNIVERSE);
    ParamFederation(const ParamFederation& fed);
    
    void add_disjunction(const ParamGuard& c);
    void add_disjunction(const ParamFederation& fed);
    void add_conjunction(const ParamGuard& c);
    void add_conjunction(const ParamFederation& fed);
    ParamFederation negation() const;
    void difference(const ParamFederation& fed);
    void future(int num_param);
    void past(int num_param);
    void reset(int var);
    void free(int var);
    void post(const ParamFederation& guard, const std::vector<int>& reset);
    void pred(const ParamFederation& guard, const std::vector<int>& reset);
    static ParamFederation predt(const ParamFederation& good,const ParamFederation& bad,int num_param);        
    void param_projection(int num_param);
    void minimize_param(int, bool *OUTPUT, int *OUTPUT, int *OUTPUT, bool *OUTPUT);
    std::string toStr() const;
    int size() const;
    bool is_empty () const;
    bool contains (const ParamFederation& ) const;
    bool is_disjoint_from(const ParamFederation& ) const;
    bool geometrically_equals(const ParamFederation& ) const;
    bool geometrically_covers(const ParamFederation& ) const;
    void pairwise_reduce ();    
};
